ArrayList<buttonClass> buttonslist = new ArrayList<buttonClass>();

int d1, d2, m1, m2, y1, y2, m, d, y;
PImage[] numberImages = new PImage[12];
//PImage[]numberImages = new PImage[12];
PImage[] signatures  = new PImage[6];
PImage slash, slash2, signature, ssignature; 
PImage bgImage; 
PGraphics alphaG, salphaG, emptySig;
boolean skinny = true;  
PFont font; 
int monthX, dayX, yearX, monthW, dayW, yearW; 
int textcounter = 0; 

long snapTimer; 
int snapInterval = 3000; 
int fade; 
int signatureNum = 0; 
boolean showDate = true; 
int wiggleRoom = 50; 
boolean scaleBoolean = false; 
int startscale; 
boolean mouseFlag; 
int endOfDate; 
int heightWiggle = 0; 
boolean setbackground; 
int totalSigs; 
/// 

PImage destination, holdimage, outputImage;  
color c, newpix;
boolean click, knob, click2, knob2; 
float alphaKnob = 200; 
float contrastKnob = 150; 
boolean enableAlpha = false; 
boolean enableContrast; 
boolean showSig = true; 
///
StringList sigFileNames; 
ArrayList<PImage> signatureImages = new ArrayList<PImage>(); 
File dir; 
File [] files;
PImage p1; 


void setup() {
  size(1300, 220);
  buttonslist = new ArrayList();
  for (int i = 0; i < 6; i ++) {
    buttonslist.add(new buttonClass((i* 200)+60, height - 30, 180, 30, i));
  }
  font = createFont("helvetica", 12); 
  textFont(font); 
  alphaG = createGraphics(width, height); 
  salphaG = createGraphics(width, height); 
  numberImages[0] = loadImage("numbers/num0.png");
  numberImages[1] = loadImage("numbers/num1.png");
  numberImages[2] = loadImage("numbers/num2.png");
  numberImages[3] = loadImage("numbers/num3.png");
  numberImages[4] = loadImage("numbers/num4.png");
  numberImages[5] = loadImage("numbers/num5.png");
  numberImages[6] = loadImage("numbers/num6.png");
  numberImages[7] = loadImage("numbers/num7.png");
  numberImages[8] = loadImage("numbers/num8.png");
  numberImages[9] = loadImage("numbers/num9.png");
  numberImages[10] = loadImage("numbers/num10.png");
  numberImages[11] = loadImage("numbers/num11.png");
  autoimport(); 
  d = day();    
  m = month();  
  y = year();
  snapTimer = millis() - snapInterval;
bgImage = loadImage("checker.jpg"); 
}

void draw() {
  background(255); 
  image(bgImage, 0, 0); 
  //if (signatureNum != 4) {
    alphaContrast();
  //}
  d1 = d/10; 
  d2 = d%10; 
  m1 = m/10; 
  m2 = m%10; 
  int joeY = y - 2000; 
  y1 = joeY/10; 
  y2 = joeY%10; 

  int locX = 10;

  if (showSig == true) {
    if (enableAlpha) {
      image(destination, locX, height/2 - destination.height/2);
    } else { 
      image(signatureImages.get(signatureNum), locX, height/2 - signatureImages.get(signatureNum).height/2);
    }
  }

  locX += signatureImages.get(signatureNum).width + wiggleRoom; 
  monthX = locX; 

  if (showDate) {
    image(numberImages[m1], locX, (height/2 -numberImages[m1].height/2) + heightWiggle); 
    locX +=numberImages[m1].width; 
    image(numberImages[m2], locX, (height/2 -numberImages[m2].height/2 ) + heightWiggle);
    locX +=numberImages[m2].width; 
    image(numberImages[10], locX, (height/2 -numberImages[10].height/2) + heightWiggle); // slash
    locX +=numberImages[10].width; 
    dayX = locX;
    image(numberImages[d1], locX, (height/2 -numberImages[d1].height/2) + heightWiggle);
    locX +=numberImages[d1].width; 
    image(numberImages[d2], locX, (height/2 -numberImages[d2].height/2) + heightWiggle);
    locX +=numberImages[d2].width; 
    image(numberImages[11], locX, (height/2 -numberImages[11].height/2) + heightWiggle); // slash
    locX +=numberImages[11].width; 
    yearX = locX;
    image(numberImages[2], locX, (height/2 -numberImages[2].height/2) + heightWiggle);
    locX +=numberImages[2].width; 
    image(numberImages[0], locX, (height/2 -numberImages[0].height/2) + heightWiggle);

    locX +=numberImages[0].width; 
    image(numberImages[y1], locX, (height/2 -numberImages[y1].height/2) + heightWiggle);
    locX +=numberImages[y1].width; 

    image(numberImages[y2], locX, (height/2 -numberImages[y2].height/2) + heightWiggle);
    endOfDate = locX + numberImages[y2].width + 30;
  }
  locX +=numberImages[y2].width; 

  image(salphaG, 0, 0);
  fill(255); 

  int st = signatureImages.get(signatureNum).width; 
  line(st, 20, st, 100); 
 // rect(st-4, 40 + heightWiggle, wiggleRoom +8, 20); 
  line(st,  50 + heightWiggle , st + wiggleRoom,  50 + heightWiggle); 
  if (scaleBoolean) {
    fill(1);
  }
  triangle(st, 50 + heightWiggle, st + 10, 45 + heightWiggle, st + 10, 55 + heightWiggle); 
  triangle(st + wiggleRoom, 50 + heightWiggle, st + wiggleRoom -10, 45 + heightWiggle, st + wiggleRoom -10, 55 + heightWiggle); 

  monthW =numberImages[m1].width +numberImages[m2].width; 
  dayW =numberImages[d1].width +numberImages[d2].width; 
  yearW =numberImages[y1].width +numberImages[y2].width +numberImages[2].width +numberImages[0].width;

  fill(0); 
  textFont(font, 16); 
  text("Signature Generator", 20, 20);
  textFont(font, 16); 
  if (textcounter > 0 ) {
    textcounter --; 
    text("Signature Saved", width - 700, 20);
  }
  textFont(font, 20); 

  if (millis() - snapTimer < snapInterval) {
    if (fade > 0) {
      fade -- ;
    }
    fill(255, fade); 
    rect (0, 0, width, height);
    fill(30, 70, 180); 
    text("saving signature and date into output folder", width - 720, 20);
  }

  if (scaleBoolean) {
    setbackground = true; 
    heightWiggle += mouseY - pmouseY;
    heightWiggle = constrain(heightWiggle, -20, 50);
    wiggleRoom += mouseX - pmouseX; 
    wiggleRoom = constrain(wiggleRoom, 30, 400);
  }

  for (int i = buttonslist.size()-1; i >= 0; i--) { 
    buttonClass dbutton = buttonslist.get(i); 
    dbutton.display();
  }

  drawKnobs();
}

void mousePressed() {
  
 // int st = signatureImages.get(signatureNum).width; 
  //line(st, 20, st, 100); 
  //rect(st-4, 40 + heightWiggle, wiggleRoom +8, 20); 
  
  if ( mouseY < 60  + heightWiggle && mouseY > 40 + heightWiggle  && mouseX >signatureImages.get(signatureNum).width 
    && mouseX < signatureImages.get(signatureNum).width + 30 + wiggleRoom) {
    scaleBoolean = true;
  }


  if (dist(mouseX, mouseY, alphaKnob, 40) < 10) {
    knob = true;
  }

  if (dist(mouseX, mouseY, 20, 40) < 10) {
    enableAlpha = !enableAlpha;
    //destination = signatureImages.get(signatureNum); 
    //destination.updatePixels();
  }
  if (dist(mouseX, mouseY, contrastKnob, 60) < 10) {
    knob2 = true;
  }
}

void mouseReleased() {
  scaleBoolean = false; 
  if ( mouseY < height/2 && mouseY > height/2 - 40) {
    if (mouseX > monthX && mouseX < monthX + monthW) {
      m ++;
      if (m > 12) {
        m = 1;
      }
    }
    if (mouseX > dayX && mouseX < dayX + dayW) {
      d ++;
      if (d > 31) {
        d = 1;
      }
    }
    if (mouseX > yearX && mouseX < yearX + yearW) {
      y ++;
    }

    //alphaG = createGraphics(width, height); 
    salphaG = createGraphics(width, height);
  }

  if ( mouseY > height/2 && mouseY < height/2 + 40) {
    if (mouseX > monthX && mouseX < monthX + monthW) {
      m --;
      if (m < 1) {
        m = 12;
      }
    }
    if (mouseX > dayX && mouseX < dayX + dayW) {
      d --;
      if (d <1) {
        d = 31;
      }
    }
    if (mouseX > yearX && mouseX < yearX + yearW) {
      y --;
    }
    salphaG = createGraphics(width, height);
  }


  knob = false;
  knob2 = false;
}

void keyPressed() {
  if (key == 's') {
    signatureNum ++;
    if (signatureNum >= totalSigs) {
      signatureNum = 0;
    }
  }

  if (keyCode == 10) {
    snapTimer = millis(); 
    fade = 255; 
    makeGraphic();
  }
}